<?php

//====================================================================
//  XML o̓NX Ver.1.01
//====================================================================
//
// 쌠
//  Copyright(C) 2005 by Shark++ Software.
//  쌠͕܂񂪁ARɎgpEEĔzz\łB
//
// NX֐̐
//
//  open_element($tag, $none_end_tag = false)
//   vf쐬܂
//
//  add_element($tag)
//   ̈؂Ȃvf쐬܂
//
//  close_element()
//   vf܂
//
//  add_attribute($attr, $value)
//   ǉ܂
//
//  add_value($text)
//   lǉ܂
//
//  set_value($text)
//   lZbg܂
//
//  flash($return_data = false)
//   XMLo͂܂
//
// eXgvO
//  | $d = new xmlgen();
//  | 
//  | $d->open_element('a');
//  | 	$d->open_element('b');
//  | 		$d->add_attribute('bb', 'bb_value');
//  | 	$d->close_element();
//  | 	$d->open_element('c');
//  | 		$d->add_value('cc');
//  | 	$d->close_element();
//  | $d->close_element();
//  | 
//  | $d->flash();
// 
//  ȏsƁAȉ̂悤ȍ\o͂܂B
//  | <a>
//  | 	<b bb="bb_value"/>
//  | 	<c>
//  | 		cc
//  | 	</c>
//  | </a>
//  ȂAo͓e͕K\̒ʂɂȂĂȂ܂B
//
// 
//  2005/05/31 
//  2005/07/17 v1.00 \[X`
//  2005/10/18 v1.01 o͎ɍsĂ鐮`C
//
//====================================================================

class xmlgen
{
	var $data;
	var $stack_count;
	var $stack_tag   = array();
	var $stack_attr  = array();
	var $stack_value = array();

	function xmlgen()
	{
		$this->stack_count = -1;
	}

	function add_element($tag)
	{
		$this->open_element($tag, true);
	}

	function open_element($tag, $none_end_tag = false)
	{
		$this->stack_count++;
		$this->stack_tag[$this->stack_count]   = $tag;
		$this->stack_attr[$this->stack_count]  = '';
		$this->stack_value[$this->stack_count] = '';

		if($none_end_tag)
		{
			$this->close_element();
		}
	}

	function close_element()
	{
		if(0 <= $this->stack_count)
		{
			if('' == $this->stack_value[$this->stack_count])
			{
				$tag  = '<'.$this->stack_tag[$this->stack_count].' />';
			}
			else
			{
				$tag  = '<'.$this->stack_tag[$this->stack_count].$this->stack_attr[$this->stack_count].'>';
				$tag .= ('<' == $this->stack_value[$this->stack_count][0] ? "\r\n" : '');
				$tag .= $this->stack_value[$this->stack_count];
				$tag .= '</'.$this->stack_tag[$this->stack_count].'>';
			}

			$this->stack_count--;

			if($this->stack_count < 0)
			{
				$this->data .= $tag."\r\n";
			}
			else
			{
				$this->stack_value[$this->stack_count] .= $tag."\r\n";
			}
		}
	}

	function add_attribute($attr, $value)
	{
		$this->stack_attr[$this->stack_count] .= ' '.$attr.'="'.$value.'"';
	}

	function set_value($text)
	{
		$this->stack_value[$this->stack_count] .= $text;
		$this->close_element();
	}

	function add_value($text)
	{
		$this->stack_value[$this->stack_count] .= $text;
	}

	function flash($return_data = false)
	{
		if($return_data)
		{
			$data = $this->data;
			$this->data = "";
			return $data;
		}
		else
		{
			$lines = explode('\n', $this->data);

			foreach($lines as $line)
			{
				echo $line."\n";
			}

			$this->data = "";
		}
	}

}

/*
	$d = new xmlgen();

	$d->open_element('a');
		$d->open_element('b');
			$d->add_attribute('bb', 'bb_value');
		$d->close_element();
		$d->open_element('c');
			$d->add_value('cc');
		$d->close_element();
	$d->close_element();

	$d->flash();
*/

?>
